﻿using Common;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

namespace ControlBindingCode
{
    public partial class UCBC : UserControl
    {
        /// <summary>
        /// CustomControl menu
        /// </summary>
        protected ObservableCollection<String> ControlMenu = new ObservableCollection<String>();
        //
        ListB myList = null;
        //
        public UCBC()
        {
            this.InitializeComponent();
        }

        public UCBC(ListB list) : this()
        {
            CreateList(list);
        }

        private void CreateList(ListB list)
        {
            myList = list;
            foreach(string item in list.List)
            {
                this.ControlMenu.Add(item);
            }
            BindingList();
        }

        private void BindingList()
        {
            ItemsControl itemsControl = new ItemsControl();
            DataTemplate dataTemplate = new DataTemplate();
            //
            itemsControl.ItemsPanel.SetMethodToInstantiateFrameworkTemplate(ItemsMenuContainerTemplateCode);
            dataTemplate.SetMethodToInstantiateFrameworkTemplate(ItemMenuTemplateCode);
            itemsControl.ItemsSource = this.ControlMenu;
            itemsControl.ItemTemplate = dataTemplate;
            StackPanel s = (StackPanel)(itemsControl.Parent);
            //
            stackPanel.Children.Add(itemsControl);
        }

        public TemplateInstance ItemsMenuContainerTemplateCode(FrameworkElement arg)
        {
            TemplateInstance templateInstance = new TemplateInstance();
            StackPanel stackPanel = new StackPanel();
            stackPanel.Orientation = Orientation.Vertical;
            if (this.myList.Orientation == Orientation.Horizontal)
            {
                stackPanel.Orientation = Orientation.Horizontal;                
            }
            this.menuOrientation.Text = "Menu orientation: " + stackPanel.Orientation.ToString();
            //
            templateInstance.TemplateContent = stackPanel;
            return templateInstance;
        }

        public TemplateInstance ItemMenuTemplateCode(FrameworkElement arg)
        {
            TemplateInstance template = new TemplateInstance();
            //
            TextBlock textBlock = new TextBlock();
            textBlock.SetBinding(TextBlock.TextProperty, new Binding());
            template.TemplateContent = textBlock;
            //
            return template;
        }
    }
}
